#ifndef MAINWINDOW_H
#define MAINWINDOW_H

#include <QMainWindow>

#include <QToolButton>
#include <QGraphicsScene>
#include <QGraphicsItem>
#include <QList>

namespace Ui {
class MainWindow;
}

class ParamList : public QMap <QString, QString>
{
   public:
      QString text (QString name);
      int number (QString name, int default_value = 0);
};

class ColorButton : public QToolButton
{
protected:
    void mousePressEvent(QMouseEvent *event);
public:
    QColor color;
};

class MainWindow : public QMainWindow
{
    Q_OBJECT

public:
    explicit MainWindow(QWidget *parent = 0);
    ~MainWindow();

    void readFile(QString fileName);
private:
    Ui::MainWindow *ui;
    QGraphicsScene * scene;

    QGraphicsRectItem * createRectangle
                        (QGraphicsItem * target,
                         ParamList & list);

    QGraphicsEllipseItem * createEllipse
                           (QGraphicsItem * target,
                            ParamList & list);

    void modifyShape (QGraphicsItem * target,
                      QAbstractGraphicsShapeItem * shape,
                      ParamList & list);

    void initPalette();
};

#endif // MAINWINDOW_H
